import { WithNetwork } from 'ataraxia';
import { AbstractPeer, PeerMessageType, PeerMessage, DisconnectReason } from 'ataraxia/transport';
import { WebSocket } from './WebSocket';
/**
 * Abstract implementation of a peer suitable for use with a WebSocket
 * instance.
 */
export declare abstract class AbstractWebSocketPeer extends AbstractPeer {
    private socket?;
    constructor(parent: WithNetwork, socket?: WebSocket);
    setSocket(socket: WebSocket): void;
    protected requestDisconnect(reason: DisconnectReason, err?: Error): void;
    disconnect(): void;
    protected handleDisconnect(reason: DisconnectReason, err?: Error): void;
    send<T extends PeerMessageType>(type: T, payload: PeerMessage<T>): Promise<void>;
}
//# sourceMappingURL=AbstractWebSocketPeer.d.ts.map