import { AbstractTransport, TransportOptions } from 'ataraxia/transport';
import { WebSocketFactory } from './WebSocketFactory';
/**
 * Options that can be used with `WebSocketClientTransport`.
 */
export interface WebSocketClientTransportOptions {
    /**
     * The URL to the websocket.
     */
    url: string;
    /**
     * Factory used to create a WebSocket.
     */
    webSocketFactory?: WebSocketFactory;
}
export declare class WebSocketClientTransport extends AbstractTransport {
    private readonly options;
    private peer?;
    constructor(options: WebSocketClientTransportOptions);
    start(options: TransportOptions): Promise<boolean>;
    stop(): Promise<boolean>;
}
//# sourceMappingURL=WebSocketClientTransport.d.ts.map